VERSION 5.00
Begin VB.Form frmAPIDemo 
   Caption         =   "API Demo (Winsock Server)"
   ClientHeight    =   5475
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7665
   ForeColor       =   &H00000000&
   LinkTopic       =   "Form1"
   ScaleHeight     =   5475
   ScaleWidth      =   7665
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      BackColor       =   &H00FFFFFF&
      Height          =   2325
      Left            =   30
      ScaleHeight     =   2265
      ScaleWidth      =   7545
      TabIndex        =   3
      Top             =   3105
      Width           =   7605
      Begin VB.Label Label2 
         BackStyle       =   0  'Transparent
         Caption         =   "Example Description"
         BeginProperty Font 
            Name            =   "Tahoma"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   60
         TabIndex        =   7
         Top             =   45
         Width           =   1830
      End
      Begin VB.Label Label5 
         BackStyle       =   0  'Transparent
         Caption         =   "This demo will show you how to implement winsock server functionality (listen/accept/send/receive) using winsock api"
         BeginProperty Font 
            Name            =   "Courier New"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H00FF0000&
         Height          =   555
         Left            =   60
         TabIndex        =   6
         Top             =   315
         Width           =   7470
      End
      Begin VB.Label Label4 
         BackStyle       =   0  'Transparent
         Caption         =   $"frmAPIDemo.frx":0000
         BeginProperty Font 
            Name            =   "Courier New"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H00000080&
         Height          =   1050
         Left            =   60
         TabIndex        =   5
         Top             =   1185
         Width           =   7470
      End
      Begin VB.Label Label6 
         BackStyle       =   0  'Transparent
         Caption         =   "API"
         BeginProperty Font 
            Name            =   "Tahoma"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   60
         TabIndex        =   4
         Top             =   915
         Width           =   1830
      End
   End
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1605
      Left            =   60
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Top             =   960
      Width           =   7545
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   360
      Left            =   45
      TabIndex        =   1
      Top             =   2655
      Width           =   1560
   End
   Begin VB.Frame Frame1 
      Appearance      =   0  'Flat
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   735
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   10000
      Begin VB.Image Image1 
         Height          =   495
         Left            =   120
         Picture         =   "frmAPIDemo.frx":012A
         Top             =   120
         Width           =   4140
      End
   End
End
Attribute VB_Name = "frmAPIDemo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This project needs a TextBox
'-> (Name)=Text1
'-> MultiLine=True
'in a form
Const PORT_TO_LISTEN = 5555
Private Sub Form_Load()
    Set Obj = Me.Text1
    Command1.Caption = "Start Listen"

    'Start subclassing
    HookForm Me
    'create a new winsock session
    StartWinsock
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
'close our connection to microsoft.com
    closesocket lSocket
    'end winsock session
    EndWinsock
    'stop subclassing
    UnHookForm Me
End Sub

Private Sub Command1_Click()
    If Command1.Caption = "Stop Listen" Then
    'Once you call shutdown then server will issue FD_CLOSE then
    'u can call closesocket to fully close the connection
        DisconnectAll
        closesocket lSocket
        Call ShowLog("Stopped Listining on port 5555...")
        Command1.Caption = "Start Listen"
    Else
        If WSAStartedUp = True Then
            lSocket = NewSocket(AF_INET, SOCK_STREAM, IPPROTO_TCP, Me.hwnd)
            If lSocket > 0 Then
                Call ShowLog("Created new socket [" & lSocket & "]..." & Now)
                If StartListen(lSocket, PORT_TO_LISTEN) <> SOCKET_ERROR Then
                    Call ShowLog("Started Listining on port 5555...")
                    Command1.Caption = "Stop Listen"
                Else
    'Call ShowLog("Error : " & GetWinsockError(Err.LastDllError))
                    Call ShowLog("Error : " & Err.LastDllError)
                    Command1.Caption = "Start Listen"
                End If
            Else
    'Call ShowLog("Error : " & GetWinsockError(Err.LastDllError))
                Call ShowLog("Error : " & Err.LastDllError)
                Command1.Caption = "Start Listen"
            End If
        End If
    End If
End Sub
Sub DisconnectAll()
'//Loop throuh all socket connected to server and close them
    For i = 1 To colConnections.Count
        shutdown colConnections(i), SD_SEND
    Next
End Sub

