Attribute VB_Name = "Module1"
'in a module

'Maximum queue length specifiable by listen.
Public Const SOMAXCONN = &H7FFFFFFF

Public colConnections As New Collection

Public Const AF_INET = 2
Public Const INVALID_SOCKET = -1
Public Const SOCKET_ERROR = -1
Public Const FD_READ = &H1&
Public Const FD_WRITE = &H2&
Public Const FD_ACCEPT = &H8
Public Const FD_CONNECT = &H10&
Public Const FD_CLOSE = &H20&
Public Const PF_INET = 2
Public Const SOCK_STREAM = 1
Public Const IPPROTO_TCP = 6
Public Const GWL_WNDPROC = (-4)
Public Const WINSOCKMSG = 1025
Public Const WSA_DESCRIPTIONLEN = 256
Public Const WSA_DescriptionSize = WSA_DESCRIPTIONLEN + 1
Public Const WSA_SYS_STATUS_LEN = 128
Public Const WSA_SysStatusSize = WSA_SYS_STATUS_LEN + 1
Public Const INADDR_NONE = &HFFFF
Public Const SOL_SOCKET = &HFFFF&
Public Const SO_REUSEADDR = &H4

Public Const SO_LINGER = &H80&
Public Const SD_SEND = &H1
Public Const SD_BOTH = &H2


Public Const hostent_size = 16
Public Const sockaddr_size = 16
Type WSADataType
    wVersion As Integer
    wHighVersion As Integer
    szDescription As String * WSA_DescriptionSize
    szSystemStatus As String * WSA_SysStatusSize
    iMaxSockets As Integer
    iMaxUdpDg As Integer
    lpVendorInfo As Long
End Type
Type HostEnt
    h_name As Long
    h_aliases As Long
    h_addrtype As Integer
    h_length As Integer
    h_addr_list As Long
End Type
Type sockaddr
    sin_family As Integer
    sin_port As Integer
    sin_addr As Long
    sin_zero As String * 8
End Type
Type LingerType
    l_onoff As Integer
    l_linger As Integer
End Type
Public Declare Function setsockopt Lib "wsock32.dll" (ByVal s As Long, ByVal Level As Long, ByVal optname As Long, optval As Any, ByVal optlen As Long) As Long
Public Declare Function getsockopt Lib "wsock32.dll" (ByVal s As Long, ByVal Level As Long, ByVal optname As Long, optval As Any, optlen As Long) As Long
Public Declare Function WSAGetLastError Lib "wsock32.dll" () As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function WSAIsBlocking Lib "wsock32.dll" () As Long
Public Declare Function WSACleanup Lib "wsock32.dll" () As Long
Public Declare Function bind Lib "ws2_32.dll" (ByVal s As Long, ByRef name As sockaddr, ByRef namelen As Long) As Long
Public Declare Function Send Lib "wsock32.dll" Alias "send" (ByVal s As Long, buf As Any, ByVal buflen As Long, ByVal flags As Long) As Long
Public Declare Function accept Lib "ws2_32.dll" (ByVal s As Long, ByRef addr As sockaddr, ByRef addrlen As Long) As Long
Public Declare Function shutdown Lib "ws2_32.dll" (ByVal s As Long, ByVal how As Long) As Long

Public Declare Function recv Lib "wsock32.dll" (ByVal s As Long, buf As Any, ByVal buflen As Long, ByVal flags As Long) As Long
Public Declare Function WSAStartup Lib "wsock32.dll" (ByVal wVR As Long, lpWSAD As WSADataType) As Long
Public Declare Function htons Lib "wsock32.dll" (ByVal hostshort As Long) As Integer
Public Declare Function ntohs Lib "wsock32.dll" (ByVal netshort As Long) As Integer
Public Declare Function socket Lib "wsock32.dll" (ByVal af As Long, ByVal s_type As Long, ByVal protocol As Long) As Long
Public Declare Function listen Lib "ws2_32.dll" (ByVal s As Long, ByVal backlog As Long) As Long
Public Declare Function closesocket Lib "wsock32.dll" (ByVal s As Long) As Long
Public Declare Function Connect Lib "wsock32.dll" Alias "connect" (ByVal s As Long, addr As sockaddr, ByVal namelen As Long) As Long
Public Declare Function WSAAsyncSelect Lib "wsock32.dll" (ByVal s As Long, ByVal hwnd As Long, ByVal wMsg As Long, ByVal lEvent As Long) As Long
Public Declare Function inet_addr Lib "wsock32.dll" (ByVal cp As String) As Long
Public Declare Function gethostbyname Lib "wsock32.dll" (ByVal host_name As String) As Long
Public Declare Sub MemCopy Lib "kernel32" Alias "RtlMoveMemory" (Dest As Any, Src As Any, ByVal cb&)
Public Declare Function inet_ntoa Lib "wsock32.dll" (ByVal inn As Long) As Long
Public Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As Any) As Long
Public Declare Function WSACancelBlockingCall Lib "wsock32.dll" () As Long

Public saZero As sockaddr
Public WSAStartedUp As Boolean, Obj As TextBox
Public PrevProc As Long, lSocket As Long

Dim strData As String ' Global variable to hold received data
Dim ReadBuffer(1 To 1024) As Byte 'Buffer of received bytes 'Max 1k

'subclassing functions
'for more information about subclassing,
'check out the subclassing tutorial at http://www.allapi.net/
Public Sub HookForm(F As Form)
    PrevProc = SetWindowLong(F.hwnd, GWL_WNDPROC, AddressOf WindowProc)
End Sub
Public Sub UnHookForm(F As Form)
    If PrevProc <> 0 Then
        SetWindowLong F.hwnd, GWL_WNDPROC, PrevProc
        PrevProc = 0
    End If
End Sub
Public Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

    If uMsg = WINSOCKMSG Then
        cnt = uMsg
        ProcessMessage wParam, lParam
    Else
        WindowProc = CallWindowProc(PrevProc, hwnd, uMsg, wParam, lParam)
    End If
End Function

'our Winsock-message handler
Public Sub ProcessMessage(ByVal lFromSocket As Long, ByVal lParam As Long)
    Dim X As Long, strDataToSend As String
    'Form1.Caption = lParam
    Select Case lParam
    Case FD_CONNECT   '
    Case FD_ACCEPT    '
        ShowLog "New connection request [socket :" & lFromSocket & "].." & Now
        SocketAccept (lFromSocket)
    Case FD_WRITE    'we can write to our connection
    Case FD_READ    'we have data waiting to be processed
        ReadDataToBuffer lFromSocket
        
        If strData <> "" Then ShowLog "Client >> " & strData
        
        If strData = "time?" Then
                strDataToSend = "Time on server is " & Now()
        ElseIf strData = "date?" Then
                strDataToSend = "Date on server is " & Date
        Else
                strDataToSend = strData & " is not a valid Command"
        End If
        
        'Send data to client
        SendDataToBuffer lFromSocket, strDataToSend

    Case FD_CLOSE    'the connection with client is closed
        'Read remaining data in the buffer
        Do
            X = recv(lFromSocket, ReadBuffer(1), 1024, 0)
            If X > 0 Then
                strData = strData & Left$(StrConv(ReadBuffer, vbUnicode), X)
            End If
        Loop Until X = 0 Or X = SOCKET_ERROR

        If strData <> "" Then ShowLog "Client >> " & strData

        closesocket lFromSocket
        ShowLog "Connection Closed... "
    End Select
End Sub
'the following functions are standard WinSock functions
'from the wsksock.bas-file
Public Function StartWinsock(Optional sDescription) As Boolean
    Dim StartupData As WSADataType
    If Not WSAStartedUp Then
        If Not WSAStartup(&H101, StartupData) Then
            WSAStartedUp = True
            sDescription = StartupData.szDescription
        Else
            WSAStartedUp = False
        End If
    End If
    StartWinsock = WSAStartedUp
End Function
Sub EndWinsock()
    Dim Ret&
    If WSAIsBlocking() Then
        Ret = WSACancelBlockingCall()
    End If
    Ret = WSACleanup()
    WSAStartedUp = False
End Sub

'************************************************************
'Sending data
'************************************************************
Public Function SendDataToBuffer(ByVal lToSocket As Long, vMessage As Variant) As Long
   Dim TheMsg() As Byte, sTemp$
   TheMsg = ""
   Select Case VarType(vMessage)
   Case 8209    'byte array
        sTemp = vMessage
       TheMsg = sTemp
   Case 8    'string, if we recieve a string, its assumed we are linemode
        sTemp = StrConv(vMessage, vbFromUnicode)
   Case Else
       sTemp = CStr(vMessage)
       sTemp = StrConv(vMessage, vbFromUnicode)
   End Select
   TheMsg = sTemp
   If UBound(TheMsg) > -1 Then
       SendDataToBuffer = Send(lToSocket, TheMsg(0), (UBound(TheMsg) - LBound(TheMsg) + 1), 0)
   End If
End Function

'************************************************************
'Reading data
'************************************************************
Function ReadDataToBuffer(lFromSocket As Long) As Long
   Dim X As Long
    strData = "" 'Clear old data before reading new one
   'start reading the data
    Do
       'Read in 1K chunk ,  ReadBuffer is a bytearray
        X = recv(lFromSocket, ReadBuffer(1), 1024, 0)
       If X > 0 Then
           strData = strData & Left$(StrConv(ReadBuffer, vbUnicode), X)
       End If
       If X <> 1024 Or X = SOCKET_ERROR Then Exit Do
   Loop
   RecvDataToBuffer = X
End Function

Public Function NewSocket(ByVal AdrFamily As Long, ByVal SckType As Long, ByVal SckProtocol As Long, HWndForMsg As Long) As Long
'********************************************************************************
'Purpose   :Creates a new socket
'Returns   :The socket handle if successful, otherwise - INVALID_SOCKET
'Arguments :AddressFamily, SocketType and SocketProtocol
'********************************************************************************
    On Error GoTo errHandler
    Dim hSocket As Long    'value returned by the socket API function
    Dim lngEvents  As Long

    'Call the socket Winsock API function in order create a new socket
    hSocket = socket(AdrFamily, SckType, SckProtocol)
    NewSocket = hSocket    'Assign returned value ( -1 => INVALID_SOCKET)

    If hSocket <> INVALID_SOCKET Then
        'The lngEvents variable contains a bitmask of events we are
        'going to catch with the window callback function.
        lngEvents = FD_CONNECT Or FD_READ Or FD_WRITE Or FD_CLOSE Or FD_ACCEPT
        '
        'Force the Winsock service to send the network event notifications
        'to the window which handle is p_lngWindowHandle.
        lngRetValue = WSAAsyncSelect(hSocket, HWndForMsg, WINSOCKMSG, lngEvents)    'Modified:04-MAR-2002
    End If
    Exit Function
errHandler:
    NewSocket = INVALID_SOCKET
End Function
Function StartListen(hSocket As Long, Port As Long) As Long
'********************************************************************************
'Purpose   :Turns a socket into a listening state.
'Return    :If no error occurs, returns zero. Otherwise, it returns SOCKET_ERROR.
'Arguments :lngSocketHandle - the socket to turn into a listening state.
'********************************************************************************
    Dim lngRetValue As Long

    If SocketBind(hSocket, Port) = SOCKET_ERROR Then StartListen = SOCKET_ERROR
    lngRetValue = listen(hSocket, SOMAXCONN)
    '
    StartListen = lngRetValue
End Function
Public Function SocketAccept(ByVal lngSocketHandle As Long) As Long
'********************************************************************************
'Purpose   :Accepts a connection request, and creates a new socket.
'Return    :If no error occurs, returns the new socket's handle.
'           Otherwise, it returns INVALID_SOCKET.
'Arguments :lngSocketHandle - the listening socket.
'********************************************************************************
'
    Dim lngRetValue         As Long
    Dim udtSocketAddress    As sockaddr
    Dim lngBufferSize       As Long
    '
    'Calculate the buffer size
    lngBufferSize = LenB(udtSocketAddress)
    '
    'Call the accept Winsock API function in order to create a new socket
    lngRetValue = accept(lngSocketHandle, udtSocketAddress, lngBufferSize)

    SocketAccept = lngRetValue
    If lngRetValue <> INVALID_SOCKET Then colConnections.Add lngRetValue
End Function

Public Function SocketBind(ByVal lngSocket As Long, ByVal lngLocalPort As Long, Optional ByVal strLocalHost As String = "127.0.0.1") As Long
'********************************************************************************
'Purpose   :Binds the socket to the local address
'Return    :If no error occurs, returns zero. Otherwise, it returns SOCKET_ERROR.
'Arguments :lngSocket    - the socket to bind
'           strLocalHost - name or IP address of the local host to bind to
'           lngLocalPort - the port number to bind to
'********************************************************************************
    On Error GoTo errHandler

    Dim udtSocketAddress As sockaddr
    Dim lngReturnValue   As Long
    Dim lngAddress       As Long

    SocketBind = SOCKET_ERROR

    With udtSocketAddress
        .sin_family = AF_INET

        '////////////////////////////////////////////////////////
        '[1] The strRemoteHost may contain the host name
        '    or IP address - GetAddressLong returns a valid
        '    value anyway
        '////////////////////////////////////////////////////////
        .sin_addr = GetHostByNameAlias(strLocalHost)

        '////////////////////////////////////////////////////////
        '[2] convert the port number to the network byte ordering
        '////////////////////////////////////////////////////////
        .sin_port = htons(lngLocalPort)
        If .sin_port = INVALID_SOCKET Then
            SocketBind = INVALID_SOCKET
            Exit Function
        End If
    End With

    '//Set option to reuse the port if its already in use
    Dim optvalue As Boolean
    optvalue = True
    If setsockopt(lngSocket, SOL_SOCKET, SO_REUSEADDR, optvalue, Len(optval)) Then
        ShowLog "Error setting SO_REUSEADDR option : " & WSAGetLastError()
    End If

    SocketBind = bind(lngSocket, udtSocketAddress, LenB(udtSocketAddress))

    Exit Function
errHandler:
    SocketBind = SOCKET_ERROR
End Function

Function GetHostByNameAlias(ByVal hostname$) As Long
    On Error Resume Next
    Dim phe&
    Dim heDestHost As HostEnt
    Dim addrList&
    Dim retIP&
    retIP = inet_addr(hostname)
    If retIP = INADDR_NONE Then
        phe = gethostbyname(hostname)
        If phe <> 0 Then
            MemCopy heDestHost, ByVal phe, hostent_size
            MemCopy addrList, ByVal heDestHost.h_addr_list, 4
            MemCopy retIP, ByVal addrList, heDestHost.h_length
        Else
            retIP = INADDR_NONE
        End If
    End If
    GetHostByNameAlias = retIP
    If Err Then GetHostByNameAlias = INADDR_NONE
End Function

Sub ShowLog(sDesc As String)
    On Error Resume Next
    Obj.Text = Obj.Text & sDesc & vbCrLf
End Sub


